/*
 * Copyright (c) 2011-2014 NecoTech.org, All rights reserved.
 */

#include <avr/io.h>
#include <util/delay.h>

#include "typedef.h"

#define XRESET	_BV(PORTD0)
#define DREQ	_BV(PORTD1)
#define XDCS	_BV(PORTD2)
#define XCS		_BV(PORTD3)

#define LED		_BV(PORTD6)

#define SM_DIFF			0
#define SM_SETTOZERO	1
#define SM_RESET		2
#define SM_OUTOFWAV		3
#define SM_PDOWN		4
#define SM_TESTS		5
#define	SM_STREAM		6
#define SM_PLUSV		7
#define	SM_DACT			8
#define	SM_SDIORD		9
#define	SM_SDISHARE		10
#define	SM_SDINEW		11
#define	SM_ADPCM		12
#define	SM_ADPCM_HP		13

#define MC_MODE		0
#define	MC_BASS		2
#define MC_VOL		0xB
#define MC_CLOCKF	3


#define SELECT_XCS		(PORTD &= ~XCS)
#define UNSELECT_XCS	(PORTD |= XCS)
#define SELECT_XDCS 	(PORTD &= ~XDCS)
#define UNSELECT_XDCS 	(PORTD |= XDCS)

#define MP3_POWER_ON()	/*(PORTD |= PORTD3)*/
#define MP3_POWER_OFF()	/*(PORTD &= ~PORTD3)*/

//#define VS1011E_SPI_SOFT
//#define VS1011E_DATA_VALIDATE
#define VS1011E_SLOW_WAIT

void set_volume();
void set_clock();
void do_sin_test();

void wait_for_ready();

void send_array(BYTE buf[], unsigned short len);
void mp3_cmd(BYTE reg, DWORD cmd);

BYTE spi_byte_soft(BYTE data);
DWORD mp3_read(BYTE reg);

void mp3_init();

void set_bass();
