/*
 * Copyright (c) 2011-2014 NecoTech.org, All rights reserved.
 */

#include <util/delay.h>
#include "spi.h"

void spi_init_high()  // 1/4
{
	SPCR = (1 << SPE) | (1 << MSTR) | (0 << SPR0) | (0 << SPR1);
}

void spi_init_low()  // 1/32
{
	SPSR = (1 << SPI2X);
	SPCR = (1 << SPE) | (1 << MSTR) | (0 << SPR0) | (1 << SPR1);
}

uint8_t spi_send(uint8_t byte)
{
	SPDR = byte;
	while (!(SPSR & (1 << SPIF)));
	return SPDR;
}

uint8_t spi_recv(void)
{
	SPDR = 0xff;
	while (!(SPSR & (1 << SPIF))) {}
	return SPDR;
}

